(*Fatih Unal*)
(* 1250885 *)

datatype let_expr = const of int | var of string | plus of let_expr * let_expr | letexpr of (string*int) list * let_expr| 
multiply of let_expr * let_expr ;

local 
val rec yeni = fn (_,nil) => false | (ilk,x::t) => (ilk=x) orelse yeni(ilk,t);
val rec eski = fn (ilk::t) => if yeni(ilk,t) then eski(t) else [ilk]@eski(t) | (_) => nil;
in 
local 
fun ay(nil,n) = n | ay(bir::m,k) = ay(m,[bir]@k)
and tak(c, nil) = var(c) | tak(r,((m:string,n:int)::k)) = case (m=r) of true => const(n) | false => tak(r,k); 
val rec w = fn (var(f),Q) => tak(f,Q)|(letexpr(Y,ene),R) => w(ene,ay(Y,R))|
(multiply(h,g),M) => multiply(w(h,M), w(g,M))|(plus(h,g),H) => plus(w(h,H), w(g,H))|(T,_) => T;
in 
fun substitute(giren) = w(giren,nil); end

local 
fun g(_,nil) = false | g(d,(s:string,c:int)::bs) = (d=s) orelse g(d,bs)
and ya(nil,_) = nil | ya(il::y,m) = case g(il, m) of true => ya(y,m) | false => [il]@ya(y,m); 
val rec p = fn (var(elf)) => [elf] | (plus(i, f)) => p(f) @ p(i) | (multiply(l,f)) => p(f) @ p(l) | 
(letexpr(Z, fat)) => ya(p(fat), Z) | (_) => nil; 
in 
fun FV (fat) = eski(p(substitute(fat:let_expr))); end

local 
fun h(plus(n, g)) = h(g)+h(n) | h(multiply(d, g)) = h(g)*h(d) | h(const(x)) = x | h(_) = ~1;
in 
fun evaluate(x)=(fn ([_],_) => NONE|(f,p) => (fn ([_],_) => NONE| (_,rp) => SOME(h(rp)))(f,substitute(p))) (FV(x),x); 
end 
end
Compiler.Control.Print.printDepth := 100;

val exp1 = const(7);
val exp10 = letexpr([("x", 1)], const(7));
val exp11 = letexpr([("x", 2)], var("x"));
val exp12 = letexpr([("x", 4), ("y", 8)], var("y"));
val exp13 = letexpr([("x", 2),("y", 8)], multiply(var("x"), var("y")));
val exp14 = letexpr([("x",2), ("y",8)],plus(multiply(var("x"), var("y")), plus(var("x"), var("y"))));
val exp15 = letexpr([("x", 2), ("y", 3)], plus(var("x"), 
				          multiply(var("y"), 
                                          letexpr([("z",4)], 
                                                  plus(const(7), var("z"))))));
val exp16 = letexpr([("x", 2), ("y", 3), ("z", 4)],
                    multiply(var("x"),
                             letexpr([("y", 30),("z", 40)],
				     multiply(var("y"),
					      letexpr([("z", 4000)],
						      plus(var("x"), plus(var("y"), var("z"))))))));
val exp17 = letexpr([("x", 2),
		     ("y", 3),
		     ("z", 4)],
		    plus(var("x"), letexpr([("t", 5)],
				      plus(multiply(var("t"), var("y")), var("z")))));
val exp18 = plus(letexpr([("x", 3), ("y", 4)], multiply(var("x"), var("y"))), letexpr([("x", 30), ("y", 40)], multiply(var("x"), var("y"))));
val exp19 = multiply(letexpr([("x", 3), ("y", 40)], plus(var("x"), var("y"))), 
                     letexpr([("x", 3), ("y", 4)], letexpr([("x", 30), ("y", 40)], plus(var("x"), var("y")))));
val exp2 = var("x");
val exp20 = plus(
			letexpr([("x", 3), ("y", 4)],
                                multiply(
						plus(letexpr([("z", 5), ("t", 6)],
                                        	             plus(var("x"), var("y"))),
						     letexpr([("x", 3), ("y", 4)],
						             plus(var("x"), var("y")))),
						letexpr([("z", 50), ("t", 60)],
						        plus(multiply(var("z"), var("x")), plus(var("t"), var("y")))))),
			letexpr([("u", 12), ("v", 10)],
				plus(multiply(
						letexpr([("y", 2), ("w", 3)],
							multiply(var("y"), var("w"))),
						letexpr([("z", 4), ("u", 3)], 
							plus(var("z"), multiply(var("u"), var("v"))))),
				     multiply(
						letexpr([("a", 2)],
							plus(multiply(var("u"), var("a")), var("v"))),
						letexpr([("b", 2), ("a", 3), ("v", 4)],
							plus(multiply(var("b"), var("a")),
							     multiply(var("u"), var("v"))))))));
val exp3 = plus(const(7), const(8));
val exp4 = plus(const(7), var("x"));
val exp5 = plus(var("y"), var("x"));
val exp6 = multiply(const(7), const(8));
val exp7 = multiply(var("x"), const(8));
val exp8 = multiply(var("x"), var("y"));
val exp9 = letexpr([], const(7));
